# fintic
## Install instructions


Run these commands in the directory you want to put the app and press enter during the setup whenever it asks for confirmation
```console
sudo apt-get update
sudo apt-get install git
git clone https://github.com/fin-tic/fintic --recursive

cd fintic
./setup.sh

```

Now to turn off the audio circuit open the config file with 
```console
sudo nano /boot/config.txt
```
look for the dtparam=audio option and turn it to off, the line should look like this. And disable bluetooth, change temp limit:
```console
dtparam=audio=off
dtoverlay=disable-bt
temp_soft_limit=70
```

```console
sudo nano /boot/cmdline.txt
```
isolcpus=3


enable ssh
```console
cd /Volumes/boot
touch ssh
```
disable hdmi, add this line above exit 0
```console
sudo nano /etc/rc.local
/usr/bin/tvservice -o
```

then reboot the pi with 
```console
sudo reboot
```

## Set to run at startup

add the startup script to crotab. Open the crontab
```console
crontab -e
```

add the line 

```console
@reboot sudo -E <path to fintic>/startup.sh &
```

dont forget the ampersand!

also make sure that the paths in startup.sh are correct for your install location 

## Install the hotspot 
```console
cd ~
curl "https://www.raspberryconnect.com/images/hsinstaller/AutoHotspot-Setup.tar.gz" -o AutoHotspot-Setup.tar.gz
tar -xzvf AutoHotspot-Setup.tar.gz
cd Autohotspot
sudo ./autohotspot-setup.sh
```
Choose option 2, then option 7 to change the SSID and password (for some reason it didnt work with the default SSID and password).

Then you can connect to the network and go to http://fintic.local:1024 or http://10.0.0.5:1024 and enter wifi information, then reboot
  
 
## Change the hostname 

To change the hostname (URL used to access the server) first open config
```console
sudo raspi-config
```
Then go to system options -> hostname and change it to e.g. fintic

You then connect to the server using the url fintic.local:1024


## Run instructions

```console
sudo -E python3 server.py
```
in browser go to url http://raspberrypi.local:1024

If it doesnt work because of a missing package try running setup.sh again, sometimes it fails to connect to the package repos
## Notes


To conver bdf font to pil format do  pilfont.py <font filename>
  pillow v 5.4.1 works, but version 8.2.0 breaks.





